let snow = [];
let friend = [];

let angle = 0;

let changeDirection;
let cloudY;

let x = 400;
let y = 350;

let cloudX = -100;
let Xcloud = -750;

let trunkLen    =  75;
let windInc     =  0.01;
let windSpeed   =  0;
let noisePos    =  0;

let springSounds;
let summerSounds;
let autumnSounds;
let winterSounds;

function preload() { //Preloads music for smoother experience
   springSounds = loadSound("song/spring.mp3");
   summerSounds = loadSound("song/summer.mp3");
   autumnSounds = loadSound("song/autumn.mp3");
   winterSounds = loadSound("song/winter.mp3");
}

function setup() {
  createCanvas(800, 600);
  //To make angle values in degrees instead of radians (default)
  angleMode(DEGREES); 

  //Make cloud bounce
   //y value for the cloud character
  cloudY = 350;
  changeDirection = false;
}



function draw() {
  //Press 1 for Spring
  if(keyCode === 49) { 
  //Keycode for '1' on the keyboard
      background(152, 211, 245);

      //Sun
      push();
      noStroke();
      fill(255, 206, 122);
      ellipse(250, 250, 200, 200);
      pop();

      //First Batch of Clouds
        //Spawns cloud variation 1
      friendly1(cloudX-200, 140, 245); 
        //Spawns cloud variation 2
      friendly2(cloudX-350, 425, 250); 
      friendly2(cloudX-250, 200, 250);
      friendly1(cloudX-100, 550, 250);

      //Second Batch of Clouds
      friendly1(Xcloud-350, 375, 245);
      friendly2(Xcloud-150, 300, 250);
      friendly2(Xcloud-250, 500, 250);
      friendly1(Xcloud-100, 100, 250);
      
      //First Batch movement
         //Cloud speed
      cloudX += 0.7;
        //If this batch of cloud reaches 1300 on the x-axis,       
      if ( cloudX >= 1300) {  
        //Next batch starts
        cloudX = -100;        
      }

      //Second Batch movement
      Xcloud += 0.7;
      if ( Xcloud >= 1300) {
        Xcloud = -100;
      }
      
      //If springSounds is played, every other sound stops
      if(!springSounds.isPlaying()){ 
        springSounds.loop();
        summerSounds.stop();
        autumnSounds.stop();
        winterSounds.stop();
      }
  
}
  //Press 2 for Summer
  else if(keyCode === 50){ 
  //Keycode for '2' on the keyboard
      background(255, 224, 122);

      push();
      noStroke();
      fill(255, 216, 89);
      translate(x - 150, y- 100);
      rotate(angle); //Rotates sunray at the back
      beam(0, 0)

      fill(255, 194, 89);
      ellipse(0, 0, 200, 200); //Creates the Sun
      pop();

      angle = angle + 0.7;

      //If summerSounds is played, every other sound stops
      if(!summerSounds.isPlaying()){ 
        springSounds.stop();
        summerSounds.loop();
        autumnSounds.stop();
        winterSounds.stop();
      }
      
    } 

   //Press 3 for Autumn 
  else if(keyCode === 51){
  //Keycode for '3' on the keyboard
      background(186, 160, 145);

      trees(-10, -100, 138, 54, 39); // Back row trees
      trees(10, -50, 105, 70, 7); //Middle row trees
      trees(-20, 0, 84, 24, 2); //Front row trees

      //If autumnSounds is played, every other sound stops
      if(!autumnSounds.isPlaying()){ 
        springSounds.stop();
        summerSounds.stop();
        autumnSounds.loop();
        winterSounds.stop();
      }

    } 

   //Press 4 for Winter
    else if(keyCode === 52){ 
    //Keycode for '4' on the keyboard
      background(7, 9, 36);
  
      let s = new Snow(random(0, 800), 0, 5, 5);
      //Makes 5x5 sized snow ranging all over canvas
      for (i = 0; i < random(3); i+=1) { 
      // For loop for snow at 3 different speeds
        snow.push(s);
      }

      //For loop to call out snow class
      for(let snows of snow) { 
        snows.move();
        snows.create();
      }
      
      //If winterSounds is played, every other sound stops
      if(!winterSounds.isPlaying()){ 
        springSounds.stop();
        summerSounds.stop();
        autumnSounds.stop();
        winterSounds.loop();
      }
    }  else {
      background(255);

        //Stops all music when going into neutral mode
        springSounds.stop();
        summerSounds.stop();
        autumnSounds.stop();
        winterSounds.stop();
    }

    //Make cloud bounce up and down
      if (cloudY > 375) {
        //Makes cloud character move up when reaching 375 on the y-axis
        changeDirection = true;   
      } else if (cloudY <= 325) {
        //Makes cloud character move down when reaching 325 on the y-axis
        changeDirection = false;  
      }

      //Speed at which cloud character moves up and down
      if (cloudY >= 0 && changeDirection == false){
        cloudY = cloudY + 0.5;
      } else if (changeDirection == true) {
        cloudY = cloudY - 0.5;
      }
    
    //Cloud character coordinates
    cloud(x, cloudY);

}

//Reference https://editor.p5js.org/cmorgantywls/sketches/HkdbRQnOG